import BsBaseComponent from './base';
import { Offcanvas } from 'bootstrap';
import type BsOffcanvasHeaderComponent from './offcanvas/header';
import type BsOffcanvasBodyComponent from './offcanvas/body';
export interface BsOffcanvasComponentSignature {
    Element: HTMLDivElement;
    Args: {
        placement?: 'start' | 'end' | 'bottom';
        onClose?: (...args: never[]) => unknown;
    };
    Blocks: {
        default: [
            {
                header: typeof BsOffcanvasHeaderComponent;
                body: typeof BsOffcanvasBodyComponent;
            }
        ];
    };
}
export default class BsOffcanvasComponent extends BsBaseComponent<BsOffcanvasComponentSignature> {
    offcanvas?: Offcanvas;
    didInsert(element: Element): void;
    willDestroy(): void;
}
declare module '@glint/environment-ember-loose/registry' {
    export default interface Registry {
        'Bs::Offcanvas': typeof BsOffcanvasComponent;
    }
}
//# sourceMappingURL=offcanvas.d.ts.map